// AistUtils.h

#pragma once

using namespace System;
using namespace System::Windows::Forms;
using namespace System::Diagnostics;
using namespace System::Runtime::InteropServices;
using namespace System::ComponentModel;

namespace Aist
{
  namespace Utils
  {
    //  
    //
    public __value enum BrowseDialogFlags
    {
      BrowseForComputer = BIF_BROWSEFORCOMPUTER,
      BrowseForPrinter = BIF_BROWSEFORPRINTER,
      BrowseIncludeFiles = BIF_BROWSEINCLUDEFILES,
      BrowseIncludeURLs = BIF_BROWSEINCLUDEURLS,
      DontGoBelowDomain = BIF_DONTGOBELOWDOMAIN,
      EditBox = BIF_EDITBOX,
      NewDialogStyle = BIF_NEWDIALOGSTYLE,
      NoNewFolderButton = BIF_NONEWFOLDERBUTTON,
      ReturnFSAncestors = BIF_RETURNFSANCESTORS,
      ReturnOnlyFSDirs = BIF_RETURNONLYFSDIRS,
      Shareable = BIF_SHAREABLE,
      StatusText = BIF_STATUSTEXT,
      UAHint = BIF_UAHINT,
      UseNewUI = BIF_USENEWUI,
      Validate = BIF_VALIDATE
    };

    //        
    //
    public __gc class ValidateFailedEventArgs : public CancelEventArgs
    {
      String* m_strInvalidName;

    public:
      ValidateFailedEventArgs(String* strInvalidName)
        : CancelEventArgs(false),          //   
          m_strInvalidName(strInvalidName)
      {
      }

      __property String* get_InvalidName()
      {
        return m_strInvalidName;
      }
    };

    //        
    //
    [Serializable]
    public __delegate void ValidateFailedEventHandler(Object* sender, ValidateFailedEventArgs* args);

    //  wrapper
    //
    public __gc __sealed class BrowseFolderDialog
    {
      String* m_strFolderName;         //  
      String* m_strInitialFolderName;  //    
      String* m_strDescription;        //  ( " ")
      String* m_strRoot;               //   

      BrowseDialogFlags m_Flags;       // 

    public private:
      //  
      // :
      // BFFM_INITIALIZE -> OnInitialize
      // BFFM_SELCHANGED -> OnSelChanged
      // BFFM_VALIDATEFAILED ->   ValidateFailed  ,
      //    -   
      //   
      //
      int BrowseCallback(HWND hWnd, UINT uMsg, LPARAM lpData);

    private:
      //   BFFM_INITIALIZE
      //
      void OnInitialize(HWND hWnd);

      //   BFFM_SELCHANGED
      //
      void OnSelChanged(HWND hWnd, LPARAM lParam);

    // 
    //
    public:
      BrowseFolderDialog()
      : m_strFolderName(new String("")),
        m_strInitialFolderName(new String("")),
        m_strDescription(new String("")),
        m_strRoot(new String(""))
      {
      }

      //  
      //
      DialogResult ShowDialog(IWin32Window* parent);

      // 
      //

      //  
      //
      __property String* get_FolderName()
      {
        return m_strFolderName;
      }

      //    
      //
      __property String* get_InitialFolderName()
      {
        return m_strInitialFolderName;
      }
      __property void set_InitialFolderName(String* strInitialFolderName)
      {
        m_strInitialFolderName = strInitialFolderName;
      }

      // 
      //
      __property String* get_Description()
      {
        return m_strDescription;
      }

      __property void set_Description(String* strDescription)
      {
        m_strDescription = strDescription;
      }

      //  
      //
      __property String* get_Root()
      {
        return m_strRoot;
      }

      __property void set_Root(String* strRoot)
      {
        m_strRoot = strRoot;
      }

      // 
      //
      __property BrowseDialogFlags get_Flags()
      {
        return m_Flags;
      }

      __property void set_Flags(BrowseDialogFlags dwFlags)
      {
        m_Flags = dwFlags;
      }

      //   BFFM_VALIDATEFAILED
      //
      __event ValidateFailedEventHandler* ValidateFailed;
	  };
  }
}
